function [coordinates, elements, dirichlet, neumann] = ...
       refineRed(coordinates, elements, dirichlet, neumann)
         
  %edgeno(i,j) = Nummer der Kante von Knoten i -> j
  edgeno=GenerateEdgeNo(elements);
   
  nC = size(coordinates,1);
  nofEdges = max(max(edgeno));
  nodof = max(max(elements));

  coordinatesOut = zeros(nofEdges+nC,2);
  coordinatesOut(1:nC,:) = coordinates;
  elementsOut = [];
  ref = sparse(nodof,nodof);
  for k = 1:size(elements,1)
    start = zeros(3,1); 
    ende  = start;
    for j = 1:3
      start(j) = elements(k,j);
      ende(j) = elements(k,rem(j,3)+1);
      
      %verfeinere Kante j, falls noch nicht verfeinert
      if(~ref(start(j),ende(j)))  
        num = edgeno(start(j),ende(j));
        coordinatesOut(nC+num,:) = (coordinates(start(j),:) + coordinates(ende(j),:))/2; 
      
        %trage neue Knotennummer 
        %in ref steht die Nummer des neuen Knotens falls Kante von i->j
        %verfeinert wird
        ref(start(j),ende(j)) = nC+num;
        if(edgeno(ende(j),start(j)))
           ref(ende(j), start(j)) = ref(start(j),ende(j));
        end
      end
     
    end
   
    elementsOut = [elementsOut; 
                   elements(k,1), ref(start(1),ende(1)), ref(start(3),ende(3));
                   elements(k,2), ref(start(2),ende(2)), ref(start(1),ende(1));
                   elements(k,3), ref(start(3),ende(3)), ref(start(2),ende(2));
                   ref(start(1),ende(1)), ref(start(2),ende(2)), ref(start(3),ende(3))];
  end
  elements = elementsOut;
  coordinates = coordinatesOut;
  
  
  
  [dirichlet, neumann] = ...
       refineBdry(ref,dirichlet,neumann);
end
  

 function varargout = refineBdry(ref,varargin) 

   for l = 1:nargin-1
     Bdry = varargin{l};
     
     varargout{l} = [];
     for k = 1:size(Bdry,1)
       if(~ref(Bdry(k,1),Bdry(k,2)))
         ref(Bdry(k,1),Bdry(k,2)) = ref(Bdry(k,2),Bdry(k,1));
       end
      varargout{l} = [varargout{l};
                      Bdry(k,1), ref(Bdry(k,1),Bdry(k,2));
                      ref(Bdry(k,1),Bdry(k,2)), Bdry(k,2)];
     end
   end
 end

   
function EdgeNo=GenerateEdgeNo(Elements)
  EdgeNo=sparse(max(max(Elements)),max(max(Elements)));
  count=0;
  for j=1:size(Elements,1)
    for k=1:3
      a=[Elements(j,k),Elements(j,rem(k,3)+1)];
      if EdgeNo(a(2),a(1))                        
        EdgeNo(a(1),a(2))=EdgeNo(a(2),a(1));
      else 
        count=count+1;
        EdgeNo(a(1),a(2))=count;
      end
    end
  end
end